<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:rss="http://purl.org/rss/1.0/"
  xmlns:rss2="http://purl.org/rss/2.0/"
  xmlns:atom="http://www.w3.org/2005/Atom"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:content="http://purl.org/rss/1.0/modules/content/"
  exclude-result-prefixes="rdf rss dc"
>
<xsl:output method="xml" indent="yes" encoding="UTF-8"/>
	<xsl:template match="/">
		<xsl:apply-templates select="//atom:feed|//rss/channel|//rdf:RDF/rss:channel"/>
	</xsl:template>

	<xsl:template match="//atom:feed|//rss/channel|//rdf:RDF/rss:channel">
		<xsl:comment> saved from url=(0014)about:internet </xsl:comment>
		<html xml:lang="ja" lang="ja">
			<head>
				<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
				<meta http-equiv="Content-Style-Type" content="text/css" />
				<title><xsl:value-of select="atom:title|title|rss:title"/> [RSS]</title>
				<link rel="stylesheet" type="text/css" href="../setting/rss/rss.css" media="screen, print" />
				<script type="text/javascript">
				function showHide(x){
				 var marker = x.parentNode.firstChild.firstChild;
				 var para = x.parentNode.parentNode.childNodes[1].getElementsByTagName("pre").item(0);
				 var span = x.parentNode.parentNode.childNodes[1].getElementsByTagName("span").item(0);
				 if(marker.data == "＋"){
				  para.style.display ="block";
				  span.style.display ="none";
				  marker.data = "－";
				 }else{
				  para.style.display ="none";
				  span.style.display ="block";
				  marker.data = "＋";
				 }
				}
			    </script>
			</head>
			<body>
				<xsl:call-template name="banner"/>
				<h1><a><xsl:attribute name="href"><xsl:value-of select="//@href|link|rss:link"/></xsl:attribute><xsl:value-of select="title|rss:title|atom:title"/></a></h1>
				<p class="channel_date"><xsl:value-of select="atom:modified|dc:date"/></p>
				<p class="lead"><xsl:value-of select="atom:tagline|description|rss:description"/></p>
				<xsl:apply-templates select="atom:entry|item|../rss:item"/>
				<xsl:call-template name="footer"/>
			</body>
		</html>
	</xsl:template>

	<xsl:template match="atom:entry|item|rss:item">
		<dl>
			<dt>
				<button class="box" title="クリックして概要の表示/非表示を切り替え" onclick="showHide(this)">+</button>
				<a>
					<xsl:attribute name="href">
						<xsl:value-of select="//@href|link|rss:link"/>
					</xsl:attribute>
					<xsl:value-of select="atom:title|title|rss:title"/>
				</a>
				<br />
				<span class="date">
					<xsl:value-of select="atom:modified|dc:date"/>
					<xsl:value-of select="dc:name"/>
				</span>
			</dt>
			<dd>
				<span>
					<xsl:copy-of select="substring(atom:content|description|rss:description,0,400)"/>
					<xsl:if test="string-length(atom:content|description|rss:description) &gt; 400">
						...
					</xsl:if>
					<br />
				</span>
				<pre>
					<xsl:copy-of select="content|rss:content"/>
				</pre>
				<xsl:apply-templates select="enclosure"/>
			</dd>
		</dl>
	</xsl:template>

	<xsl:template match="enclosure">
		<span>添付ファイル:<a><xsl:attribute name="href"><xsl:value-of select="@url"/></xsl:attribute><xsl:value-of select="@type"/></a>(<xsl:value-of select="@length"/>byte)</span>
	</xsl:template>

	<xsl:template name="banner">
	</xsl:template>


	<xsl:template name="footer">
		<xsl:param name="status"/>
		<hr class="hidden" />
		<div class="footer">
			<p><span class="copyright"></span></p>
		</div>
 </xsl:template>

<xsl:template match="br">
<br />
</xsl:template>

</xsl:stylesheet>
