#if !defined(PATRIOT_CLASS_ACCELERATORMANAGER)
#define PATRIOT_CLASS_ACCELERATORMANAGER

#include "StdAfx.h"
#include "patriotGlobal2.h"
#include "resource.h"

class CAcceleratorManager{
public:
	HACCEL m_hAccel;
	ACCEL* m_pAccel;
	int m_count;


	CAcceleratorManager()
	{
		m_hAccel = HACCEL(0);
		m_hAccel = ::LoadAccelerators(::AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDR_MAINFRAME));
		SetHAccel(m_hAccel);
	}

	CAcceleratorManager( HACCEL hAccel )
	{
		SetHAccel(hAccel);
	}

	~CAcceleratorManager(){
		if (m_pAccel) delete m_pAccel;
	}

	void SetHAccel( HACCEL hAccel )
	{
		m_hAccel =hAccel;
		m_count  =::CopyAcceleratorTable(m_hAccel, NULL, 0);
		m_pAccel =new ACCEL[m_count];
		::CopyAcceleratorTable(m_hAccel, m_pAccel, m_count);
	}

	void Add( int cmd, int key, BYTE fVirt )
	{ // L[ǉ
		int index = m_count;
		SetCount( m_count + 1 );

		m_pAccel[index].key   = WORD( key );
		m_pAccel[index].cmd   = WORD( cmd );
		m_pAccel[index].fVirt = fVirt;
	}

	void Delete( int index )
	{ // 폜
		m_count--;
		ACCEL* pAccel = new ACCEL[m_count];

		int i = 0;
		for (i = 0; i < index; i++) {
			pAccel[i]=m_pAccel[i];
		}
		for (i = index; i < m_count; i++) {
			pAccel[i]=m_pAccel[i+1];
		}
		delete[] m_pAccel;
		m_pAccel = pAccel;
	}

	void SetCount(int count)
	{ // TCYݒ
		ACCEL* pAccel = new ACCEL[count];
		if (count >= m_count) {
			for (int i = 0; i < m_count; i++) {
				pAccel[i] = m_pAccel[i];
			}
		}
		m_count = count;
		delete[] m_pAccel;
		m_pAccel = pAccel;
	}

	HACCEL LoadAccel( CString strPath )
	{ // t@C֓ǂݍ
		DestroyAcceleratorTable(m_hAccel);

		m_count = 0;
	  #if 1 //def UNICODE
		CString str;												//+++
		CReadTextFile file( strPath, CFile::modeRead ); 			//+++
		//TCHAR* str	= const_cast<TCHAR*>(LPCTSTR( strBuf ));	//+++
		while (file.ReadString( str, MAX_PATH ))
	  #else // 
		TCHAR str[MAX_PATH];
		CStdioFile file( strPath, CFile::modeRead );
		while (file.ReadString( str, MAX_PATH ))
	  #endif
		{
			if (str.IsEmpty())
				continue;
			TCHAR*	strKey	= (TCHAR*)LPCTSTR(str);

			TCHAR* strCmd = _tcschr( strKey, _T(',') );
			if (strCmd == NULL) //+++
				continue;
			*strCmd = _T('\0');
			strCmd++;


			TCHAR* strVirt = _tcschr( strCmd, _T(',') );
			if (strVirt == NULL)	//+++
				continue;
			*strVirt = _T('\0');
			strVirt++;

			m_pAccel[m_count].key	= WORD( _ttoi( strKey  ) );
			m_pAccel[m_count].cmd	= WORD( _ttoi( strCmd  ) );
			m_pAccel[m_count].fVirt = BYTE( _ttoi( strVirt ) );

			if (m_count++ % 32 == 0) {
				SetCount( m_count + 32 );
				m_count -= 32;
			}
		}
		file.Close();
		m_hAccel = CreateAcceleratorTable(m_pAccel, m_count);
		return m_hAccel;
	}

	void SaveAccel( CString strPath )
	{ // t@Cɏ
		//+++ CStdioFile file( strPath, CFile::modeCreate | CFile::modeWrite );
		CWriteTextFile file( strPath, CFile::modeCreate | CFile::modeWrite );
		for (int i = 0; i < m_count; i++) {
			CString str;
			str.Format( _T("%d,%d,%d\n"), m_pAccel[i].key, m_pAccel[i].cmd, m_pAccel[i].fVirt );

			file.WriteString(str);
		}
		file.Close();
	}

	CString GetKeyName(UINT ID)
	{ // L[擾
		CString str= _T("");
		int i;
		for (/*int*/ i = 0; i < m_count - 1; i++) {
			if (m_pAccel[i].cmd == ID) {
				break;
			}
		}
		if (m_pAccel[i].cmd != ID) {
			return _T("");
		}
		// ɕϊ
		if (m_pAccel[i].fVirt & FALT) {
			str += _T("Alt+");
		}
		if (m_pAccel[i].fVirt & FCONTROL) {
			str += _T("Ctrl+");
		}
		if (m_pAccel[i].fVirt & FSHIFT) {
			str += _T("Shift+");
		}
		str += ConvertAscii(m_pAccel[i].key);
		return str;
	}

	CString GetKeyName_Index( int index )
	{ // L[擾
		CString str= _T("");
		int i = index;
		// ɕϊ
		if (m_pAccel[i].fVirt & FALT) {
			str += _T("Alt+");
		}
		if (m_pAccel[i].fVirt & FCONTROL) {
			str += _T("Ctrl+");
		}
		if (m_pAccel[i].fVirt & FSHIFT) {
			str += _T("Shift+");
		}
		str += ConvertAscii(m_pAccel[i].key);
		return str;
	}

	static CString ItoStr( int value )
	{ // l𕶎
		TCHAR chr[64];
		_itot( value, &chr[0], 10 );
		return chr;
	}

	static CString ConvVirtKeyToStr(UINT nChar)
	{
		if (0x41 <= nChar && nChar <= 0x5A)  return (TCHAR)nChar;	//+++ TCHAR
		if (0x30 <= nChar && nChar <= 0x39)  return (TCHAR)nChar;	//+++ TCHAR
		if (0x60 <= nChar && nChar <= 0x69)  return _T("Num ") + ItoStr(nChar - 0x60);
		if (0x70 <= nChar && nChar <= 0x87) return _T('F') + ItoStr(nChar - 0x6F);
		switch(nChar){
		case 0x8 :return  _T("Backspace");
		case 0x9 :return  _T("Tab");
		case 0xc :return  _T("Clear");
		case 0xd :return  _T("Enter");
		case 0x13:return  _T("Pause");
		case 0x14:return  _T("Capital");
		case 0x1b:return  _T("Esc");
		case 0x1c:return  _T("ϊ");
		case 0x1d:return  _T("ϊ");
		case 0x20:return  _T("Space");
		case 0x21:return  _T("Page Up");
		case 0x22:return  _T("Page Down");
		case 0x23:return  _T("End");
		case 0x24:return  _T("Home");
		case 0x25:return  _T("Left");
		case 0x26:return  _T("Up");
		case 0x27:return  _T("Right");
		case 0x28:return  _T("Down");
		case 0x29:return  _T("Select");
		case 0x2B:return  _T("Execute");
		case 0x2C:return  _T("Print Screen");
		case 0x2D:return  _T("Ins");
		case 0x2E:return  _T("Del");
		case 0x2F:return  _T("Help");
		case 0x5B:return  _T("Left Windows");
		case 0x5C:return  _T("Right Windows");
		case 0x5D:return  _T("Application");
		case 0x6A:return  _T("Num *");
		case 0x6B:return  _T("Num +");
		case 0x6C:return  _T("Num ,");
		case 0x6D:return  _T("Num -");
		case 0x6E:return  _T("Num .");
		case 0x5F:return  _T("Num /");
		case 0x90:return  _T("Num Lock");
		case 0x91:return  _T("Scroll Lock");
		case 0xBA:return  _T(":");
		case 0xBB:return  _T(";");
		case 0xBC:return  _T(",");
		case 0xBD:return  _T("-");
		case 0xBE:return  _T(".");
		case 0xBF:return  _T("/");
		case 0xC0:return  _T("@");
		case 0xDB:return  _T("[");
		case 0xDC:return  _T("\\");
		case 0xDD:return  _T("]");
		case 0xDE:return  _T("^");
		case 0xDF:return  _T("_");
		case 0xE2:return  _T("\\");
		case 0xE5:return  _T("Ђ炪");
		case 0xF0:return  _T("Caps Lock");
		}
		return _T("'") + ItoStr(nChar) + _T("'");
	}
protected:
	CString ConvertAscii( UINT nChar )
	{
		return ConvVirtKeyToStr(nChar);
	}

	void WriteProfileInt( LPCTSTR strKey, int iValue, LPCTSTR strFile )
	{ // iniɏ
		::WritePrivateProfileString( _T("Accelerator"), strKey, ItoStr(iValue), strFile );
	}

	int GetProfileInt( LPCTSTR strKey, LPCTSTR strFile )
	{ // iniɏ
		return ::GetPrivateProfileInt( _T("Accelerator"), strKey, 0, strFile );
	}
};

#endif
