///////////////////////////////////////////////////////////////////
// DynamicMenuManager.cpp
// Ij[ǗNX
///////////////////////////////////////////////////////////////////


#include "stdafx.h"
#include "DynamicMenuManager.h"
#include "PatriotView.h"
#include "resource.h"
#include "PatriotGlobal.h"

///////////////////////////////////////////////////////////////////
/// CDynamicMenuManager
///////////////////////////////////////////////////////////////////

/// RXgN^
CDynamicMenuManager::CDynamicMenuManager()
	: m_FileNames()
	, m_bMenuLoaded(0)
	, m_nFirstItemID(0)
{
}

/// fXgN^
CDynamicMenuManager::~CDynamicMenuManager()
{
}

/// R}hs
CString CDynamicMenuManager::GetCommandFile(UINT nID)
{
	UINT nIndex = nID - m_nFirstItemID;
	return m_FileNames.GetAt(nIndex);
}

/// ڐ擾
int CDynamicMenuManager::GetItemCount()
{
	return	int(m_FileNames.GetSize());
}


///////////////////////////////////////////////////////////////////
/// CFolderMenuManager
///////////////////////////////////////////////////////////////////

/// RXgN^
CFolderMenuManager::CFolderMenuManager(UINT nFirstItemID, UINT nRootFlagID, LPCTSTR lpszFileExt)
	: CDynamicMenuManager()
	, m_strRootFolder()
	, m_strFileExt(lpszFileExt)
	, m_nRootFlagID(nRootFlagID)
	, m_nItemBreakCount(0)
	, m_nMaxTextLength(0)
	, m_FolderNames()
	, m_FolderHandles()
{
	m_nFirstItemID = nFirstItemID;		//+++ :CDynamicMenuManager̃o[̏.
	//+++ m_nRootFlagID = nRootFlagID;
	//+++ m_strFileExt	= lpszFileExt;
}

/// 
void CFolderMenuManager::Initialize(LPCTSTR lpszRootFolder, int nItemBreakCount, int nMaxTextLength )
{
	m_strRootFolder   = lpszRootFolder;
	m_nItemBreakCount = nItemBreakCount;
	m_nMaxTextLength  = nMaxTextLength;
}

/// j[쐬
void CFolderMenuManager::CreateMenu(CMenu* pPopupMenu)
{
	CStringArray arrStr;
	UINT i = 0, pos = 0;
	BOOL bRoot = FALSE;

	for (i = 0; i < pPopupMenu->GetMenuItemCount(); i++) {
		if (pPopupMenu->GetMenuItemID(i) == m_nRootFlagID) {
			bRoot = TRUE;
		}
	}

	if (bRoot) {
		// ŏ㉺w
		m_FileNames.RemoveAll();
		m_FolderNames.RemoveAll();
		m_FolderHandles.RemoveAll();

		m_FolderNames.Add(m_strRootFolder);
		m_FolderHandles.Add(reinterpret_cast<void*>(pPopupMenu->m_hMenu));	//+++@ UINTvoid*

		pos = 4;
		// Zp[^[̈ʒu擾
		TCHAR chrBuf[MAX_PATH];
		MENUITEMINFO minfo = {0};
		chrBuf[0]		 = 0;
		minfo.dwTypeData = chrBuf;
		minfo.cbSize	 = sizeof(MENUITEMINFO);
		UINT nItemCount  = pPopupMenu->GetMenuItemCount();

		for (i = 0; i < nItemCount; i++) {
			minfo.fMask = MIIM_TYPE;
			pPopupMenu->GetMenuItemInfo( i, &minfo, TRUE );
			if ( minfo.fType & MFT_SEPARATOR ) {
				pos = i + 1;
				break;
			}
		}
	} else {
		pos = 0;
	}

	// CfbNX
	int index;	//+++
	for (/*int*/ index = 0; index < m_FolderHandles.GetSize(); index++) {
		//+++@ if ((UINT)pPopupMenu->m_hMenu == (UINT)m_FolderHandles.GetAt(index)) {
		if ((HANDLE)pPopupMenu->m_hMenu == (HANDLE)m_FolderHandles.GetAt(index)) {
			break;
		}
	}
	if (index == m_FolderHandles.GetSize() && (index == 0 || pPopupMenu->m_hMenu != (HMENU)m_FolderHandles.GetAt(index-1))) {	//+++ cast chg.
		return;
	}
	CString strFolder = m_FolderNames.GetAt(index);

	// 폜
	UINT nItemCount = pPopupMenu->GetMenuItemCount();
	while (nItemCount > pos) {
		pPopupMenu->DeleteMenu( nItemCount - 1, MF_BYPOSITION );
		nItemCount--;
	}

	// tH_ݒ胁j[ǉ
	AppendOptionalMenu(pPopupMenu, index);

	// tH_ǂݍ
	LoadFolderToArray( strFolder, arrStr );

	// ACeo^Ȃ
	if (arrStr.GetSize() == 0) {
		pPopupMenu->AppendMenu(MF_STRING | MF_GRAYED, m_nFirstItemID, _T("(Ȃ)") );
		return;
	}

	// c[ɒǉ
	UINT	nFolderItemCount = UINT( arrStr.GetSize() );
	CString strUpperExt 	 = m_strFileExt;
	strUpperExt.MakeUpper();
	for (i = 0; i < nFolderItemCount; i++) {
		CString strFileName = arrStr.GetAt(i);
		CString strItem 	= arrStr.GetAt(i);

		//if (g_Options.FavoritesMaxTitle > 0) {
		if (m_nMaxTextLength > 0) {
			strItem = strItem.Left( m_nMaxTextLength );
		}

		if (strItem.Find(_T('&')) > 0) {
			strItem.Replace( _T("&"), _T("&&"));
		}

		//UINT nFlag = (g_Options.FavoritesMenuBreak > 0 && pPopupMenu->GetMenuItemCount() % (g_Options.FavoritesMenuBreak) == 0) ? MF_STRING | MF_MENUBARBREAK : MF_STRING;
		UINT nFlag = (m_nItemBreakCount > 0 && pPopupMenu->GetMenuItemCount() % m_nItemBreakCount == 0) ? MF_STRING | MF_MENUBARBREAK : MF_STRING;

		if (strFileName.GetLength() > 5
			&& (strFileName.Right(m_strFileExt.GetLength()) == m_strFileExt
				|| strFileName.Right(strUpperExt.GetLength()) == strUpperExt
				|| strFileName.Right(4) == _T(".lnk") ) ) {
			// t@C
			if (strItem.GetLength() > 5 && strItem.GetAt(strItem.GetLength() - 4) == _T('.')) {
				strItem = strItem.Left(strItem.GetLength() - 4);
			}
			m_FileNames.Add( strFolder + _T("\\") + strFileName );
			pPopupMenu->AppendMenu(nFlag, m_nFirstItemID + m_FileNames.GetSize() - 1, strItem);
		} else {
			// tH_
			CMenu* pMenu = new CMenu;
			pMenu->CreatePopupMenu();
			pMenu->AppendMenu( MF_STRING, NULL, _T("") );
			pPopupMenu->AppendMenu( MF_POPUP | nFlag, (UINT_PTR)pMenu->m_hMenu, strItem );	//+++@ ?_PTR
			m_FolderHandles.Add( reinterpret_cast<void*>(pMenu->m_hMenu) ); //+++@ UINTvoid*
			m_FolderNames.Add( strFolder + _T("\\") + strFileName );
			pMenu->Detach();
			delete pMenu;
		}
	}
}

/// tH_̒gzɓǂݍ
void CFolderMenuManager::LoadFolderToArray(LPCTSTR lpszFileName, CStringArray& array)
{
	LoadArrFolder(array, lpszFileName, _T("*") );
}

/// tH_ݒ̃j[ǉ
void CFolderMenuManager::AppendOptionalMenu(CMenu* pPopupMenu, int nItemIndex)
{
}


///////////////////////////////////////////////////////////////////
/// CFavoritesMenuManager
///////////////////////////////////////////////////////////////////

/// RXgN^
CFavoritesMenuManager::CFavoritesMenuManager(UINT nFirstItemID, UINT nRootFlagID, LPCTSTR lpszFileExt)
	: CFolderMenuManager(nFirstItemID, nRootFlagID, lpszFileExt)
	, m_bUseAddHere(0)		// uɒǉv\
	, m_bUseOpenAll(0)		// uׂĊJv\
	, m_bLoadIEOrder(0) 	// IEɕׂ
{
}

/// }bvɃtH_ǉ
void CFavoritesMenuManager::SetRootFolder(HMENU hMenu, LPCTSTR lpszFolder)
{
	m_FolderHandles.RemoveAll();
	m_FolderNames.RemoveAll();

	m_FolderHandles.Add(reinterpret_cast<void*>(hMenu));	//+++@ UINTvoid*
	m_FolderNames.Add(lpszFolder);
}

/// 
void CFavoritesMenuManager::Initialize(LPCTSTR lpszRootFolder, int nItemBreakCount, int nMaxTextLength
									   , BOOL bLoadIEOrder, BOOL bUseAddHere, BOOL bUseOpenAll)
{
	m_bLoadIEOrder = bLoadIEOrder;
	m_bUseAddHere  = bUseAddHere;
	m_bUseOpenAll  = bUseOpenAll;

	CFolderMenuManager::Initialize(lpszRootFolder, nItemBreakCount, nMaxTextLength );
}

// tH_CfbNX擾
CString CFavoritesMenuManager::GetFolderPath(int index)
{
	return m_FolderNames.GetAt(index);
}

/// tH_̒gzɓǂݍ
void CFavoritesMenuManager::LoadFolderToArray(LPCTSTR lpszFileName, CStringArray& array)
{
	// IE
	if (m_bLoadIEOrder) {
		LoadRegFavorites(array, lpszFileName);
	} else {
		LoadArrFolder(array, lpszFileName, _T("*") );
	}
}

/// tH_ݒ̃j[ǉ
void CFavoritesMenuManager::AppendOptionalMenu(CMenu* pPopupMenu, int nItemIndex)
{
	int index = nItemIndex;
	// ̃tH_ɒǉ
	if (m_bUseAddHere) {
		pPopupMenu->AppendMenu(MF_STRING, ID_FAVORITES_ADDHERE + index, _T("Ƀy[Wǉ(&A)") );
	}
	// ̃tH_ׂĊJ
	if (m_bUseOpenAll) {
		pPopupMenu->AppendMenu(MF_STRING, ID_FAVORITES_OPENALL + index, _T("̃tH_ׂĊJ(&O)") );
	}
	if (m_bUseAddHere || m_bUseOpenAll) {
		pPopupMenu->AppendMenu(MF_SEPARATOR, NULL, _T("") );
	}
}


///////////////////////////////////////////////////////////////////
/// CSendMenuManager
///////////////////////////////////////////////////////////////////

/// RXgN^
CSendMenuManager::CSendMenuManager(LPCTSTR lpszFileName, UINT nFirstItemID)
{
	m_strFileName  = lpszFileName;
	m_nFirstItemID = nFirstItemID;
	m_bMenuLoaded  = FALSE;
}

/// fXgN^
CSendMenuManager::~CSendMenuManager()
{
}

/// j[ǂݍ
void CSendMenuManager::Load(LPCTSTR lpszFileName)
{
	m_bMenuLoaded = TRUE;
	m_FileNames.RemoveAll();

	CString str;
	TRY{
		//+++ CStdioFile fin(lpszFileName, CFile::modeRead);
		CReadTextFile	fin(lpszFileName, CFile::modeRead);
		while (fin.ReadString(str)) {
			if (str.GetAt(0) != _T('#')) {
				m_FileNames.Add(str);
			}
		}
		fin.Close();
	} CATCH (CFileException, e) {
		if (e->m_cause != CFileException::fileNotFound) {
			TRACE( _T("File could not be opened %d \n")  , e->m_cause);
		}
	} END_CATCH
}

/// ݒj
void CSendMenuManager::Release()
{
	m_bMenuLoaded = FALSE;
	m_FileNames.RemoveAll();
}

/// R}hs
CString CSendMenuManager::GetCommandFile(UINT nID)
{
	if (!IsSettingLoaded()) {
		Load(m_strFileName);
	}
	return CDynamicMenuManager::GetCommandFile(nID);
}

/// j[쐬
void CSendMenuManager::CreateMenu(CMenu* pPopupMenu)
{
	if (!IsSettingLoaded()) {
		Load(m_strFileName);
	}

	while (pPopupMenu->GetMenuItemCount() > 0) {
		pPopupMenu->DeleteMenu( 0, MF_BYPOSITION );
	}

	CString str;
	UINT size = UINT( m_FileNames.GetSize() );

	for(UINT i = 0; i < size; i++) {
		str = m_FileNames.GetAt(i);
		if ( str.Left(2) == _T("--") ){ // Zp[^[
			pPopupMenu->AppendMenu( MF_SEPARATOR, 0, _T("") );
		} else if (!str.IsEmpty()) {
			pPopupMenu->AppendMenu( MF_STRING, m_nFirstItemID + i, str );
		}
	}
}


///////////////////////////////////////////////////////////////////
/// CProxyMenuManager
///////////////////////////////////////////////////////////////////

/// RXgN^
CProxyMenuManager::CProxyMenuManager(LPCTSTR lpszFileName, UINT nFirstItemID)
	:CSendMenuManager(lpszFileName, nFirstItemID)
{
}

/// j[ǂݍ
void CProxyMenuManager::Load(LPCTSTR lpszFileName)
{
	CSendMenuManager::Load(lpszFileName);

	m_FileNames.InsertAt(0, _T(""));
	m_FileNames.InsertAt(1, _T("InternetOption"));
}

/// j[쐬
void CProxyMenuManager::CreateMenu(CMenu* pPopupMenu)
{
	if (!IsSettingLoaded()) {
		Load(m_strFileName);
	}

	while (pPopupMenu->GetMenuItemCount() > 0) {
		pPopupMenu->DeleteMenu( 0, MF_BYPOSITION );
	}
	pPopupMenu->AppendMenu( MF_STRING,	  m_nFirstItemID + 0, _T("ڐڑ(&D)")	   );
	pPopupMenu->AppendMenu( MF_STRING,	  m_nFirstItemID + 1, _T("IE̐ݒŐڑ(&I)") );
	pPopupMenu->AppendMenu( MF_SEPARATOR, NULL				, _T("---") 			   );

	CString str;
	UINT	size = UINT( m_FileNames.GetSize() );

	for(UINT i = 2; i < size; i++) {
		str = m_FileNames.GetAt(i);
		if ( str.Left(2) == _T("--") ){ // Zp[^[
			pPopupMenu->AppendMenu( MF_SEPARATOR, 0, _T("") );
		} else if (!str.IsEmpty()) {
			pPopupMenu->AppendMenu( MF_STRING, m_nFirstItemID + i, str );
		}
	}
}


///////////////////////////////////////////////////////////////////
/// CExtensionMenuManager
///////////////////////////////////////////////////////////////////

/// RXgN^
CExtensionMenuManager::CExtensionMenuManager(LPCTSTR lpszFileName, UINT nFirstItemID)
	:CSendMenuManager(lpszFileName, nFirstItemID)
{
}

/// R}hs
CString CExtensionMenuManager::GetCommandFile(UINT nID)
{
	return CDynamicMenuManager::GetCommandFile(nID);
}

/// j[ݒ擾
UINT CExtensionMenuManager::GetCommandMenuOption(UINT nID)
{
	UINT nIndex = nID - m_nFirstItemID;
	return m_MenuOptions.GetAt(nIndex);
}

/// j[쐬
void CExtensionMenuManager::CreateMenu(CMenu* pPopupMenu)
{
	while (pPopupMenu->GetMenuItemCount() > 0) {
		pPopupMenu->DeleteMenu( 0, MF_BYPOSITION );
	}

	m_FileNames.RemoveAll();
	m_FileNames.SetSize( 256 );
	m_MenuOptions.RemoveAll();
	m_MenuOptions.SetSize( 256 );

	CMenu* pFolderMenu[16];
	CString strFolerName[16];
	int iCurTreeDepth = 0;
	pFolderMenu[0] = pPopupMenu;

	CString str;

	//+++ CStdioFile fin(m_strFileName, CFile::modeRead);
	CReadTextFile fin(m_strFileName, CFile::modeRead);
	while (fin.ReadString( str )) {
		str.TrimLeft();

		if (str.GetLength() >= 5 && str.Left(5) == _T("ITEM:") ) {
			// ACe
			str = str.Mid(5);
			//str = str.Right( str.GetLength() - 5 );

			CString strName, strAccel, strID;
			SplitStr(str, _T(','), strName,  str);
			SplitStr(str, _T(','), strAccel, str);
			SplitStr(str, _T(','), str, 	 strID);

			UINT nID	 = _ttoi(strID);
			UINT nOption = _ttoi(str);

			m_FileNames.SetAt( nID, strName );
			m_MenuOptions.SetAt( nID, nOption );

			if (!strAccel.IsEmpty()) {
				strName += _T("(&") + strAccel + _T(")");
			}
			pFolderMenu[ iCurTreeDepth ]->AppendMenu( MF_STRING, m_nFirstItemID + nID, strName );
		} else if (str.GetLength() >= 6 && str.Left(6) == _T("GROUP:") ) {
			// tH_Jn
			str = str.Mid(6);

			CString strAccel;
			SplitStr(str, _T(','), str, strAccel);
			if (strAccel!= _T("") ) {
				str = str+ _T("(&") + strAccel + _T(")");
			}

			iCurTreeDepth++;
			strFolerName[iCurTreeDepth] = str;
			pFolderMenu[iCurTreeDepth] = new CMenu;
			pFolderMenu[iCurTreeDepth]->CreatePopupMenu();
		} else if (str.GetLength() >= 8 && str.Left(8) == _T("ENDGROUP") ) {
			// tH_I
			pFolderMenu[ iCurTreeDepth - 1 ]->AppendMenu( MF_POPUP | MF_STRING,
															 (UINT_PTR)pFolderMenu[ iCurTreeDepth ]->m_hMenu,	//+++@ ?_PTR.
															 strFolerName[ iCurTreeDepth ] );
			pFolderMenu[ iCurTreeDepth ]->Detach();
			delete pFolderMenu[ iCurTreeDepth ];
			iCurTreeDepth--;
		} else if (str.GetLength() >= 9 && str.Left(9) == _T("SEPARATOR") ) {
			// Zp[^[
			pFolderMenu[ iCurTreeDepth ]->AppendMenu( MF_SEPARATOR, 0, _T("") );
		}
	}
	fin.Close();

	int i;
	for (i = 255; i >= 0; i--) {
		if (!m_FileNames.GetAt(i).IsEmpty()) {
			break;
		}
	}
	m_FileNames.SetSize(i + 1);
}
