///////////////////////////////////////////////////////////////////
// FavoritesOrder.cpp
// Cɓ̕яǗNX
// Marged from unDonut
///////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FavoritesOrder.h"
#include "patriot.h"
#include "patriotGlobal.h"
#include "GlobalOption.h"
#include <shlwapi.h>
// STL
#include <algorithm>
#include <iterator>
#include <functional>
//#include <boost/shared_ptr.hpp>

/// URL ŗACer
struct CFavoritesOrder::LessFavoritesDataByName : std::less<CFavoritesOrder::CFavoritesOrderData>
{
	bool operator()(const CFavoritesOrder::CFavoritesOrderData& x, const CFavoritesOrder::CFavoritesOrderData& y) const
	{
		BOOL bIsXFolder = (x.name.Find(_T(".url")) == -1);
		BOOL bIsYFolder = (y.name.Find(_T(".url")) == -1);
		if ((bIsXFolder && !bIsYFolder)
			|| (bIsXFolder == bIsYFolder && ::lstrcmp(x.name, y.name) < 0)) {
			return true;
		}
		return false;
	}
};

///////////////////////////////////////////////////////////////////
// CFavoritesOrder
///////////////////////////////////////////////////////////////////

/// z̕яWXgɋL^
BOOL CFavoritesOrder::SaveOrder()
{
	// t@CɃ\[g
	CFavoritesOrderDataVector datalist_sorted(m_datalist);
	std::sort(datalist_sorted.begin(), datalist_sorted.end(), LessFavoritesDataByName());

	/*
	CString str = "write:\n";
	for (CFavoritesOrderDataVector::iterator pos2 = datalist_sorted.begin(); pos2 != datalist_sorted.end(); pos2++) {
		str += ItoStr((*pos2).priority) + _T("\t:") + ItoStr((*pos2).size) + _T("\t:") + (*pos2).name + _T("\n");
	}
	AfxMessageBox(str);
	*/

	// o
	enum{IE_MENUORDER_UNKNOWN1 = 2, IE_MENUORDER_UNKNOWN2 = 1};
	// TCYm肳
	DWORD	dwFullSize	= 0;
	int 	count 		= 0;
	for (CFavoritesOrderDataVector::iterator i = datalist_sorted.begin(); i != datalist_sorted.end(); i++) {
		CFavoritesOrderData& data = *i;
		if (data.priority == -1) {
			continue;
		}
		dwFullSize += data.size;
		count++;
	}
	//wb_𑫂
	dwFullSize += sizeof(OrderDataHeader);

	//m
	LPBYTE lpMem = new BYTE[dwFullSize];
	if(!lpMem) {
		ASSERT(true);
		return FALSE;
	}
	::memset(lpMem, 0, dwFullSize);

	LPBYTE lpData = lpMem;

	//wb_f[^i[
	OrderDataHeader* pHeader = (OrderDataHeader*)lpData;
	pHeader->dwSize8	  = 8;
	pHeader->dwFullSizem8 = dwFullSize - pHeader->dwSize8;
	pHeader->dwUnknown	  = IE_MENUORDER_UNKNOWN1;
	pHeader->dwUnknown2   = IE_MENUORDER_UNKNOWN2;
	pHeader->dwItemCount  = count;
	lpData += sizeof(OrderDataHeader);

	//ACe𕡎
	for (CFavoritesOrderDataVector::iterator pos = datalist_sorted.begin(); pos != datalist_sorted.end(); pos++) {
		CFavoritesOrderData& data = *pos;
		if (data.priority == -1) {
			continue;
		}
		LPBYTE lpStart = lpData;

		TCHAR szFileName[MAX_PATH];
		/*+++ BOOL bResult =*/ ::SHGetPathFromIDList(data.spidl.get(), szFileName);
		/*
		if (data.name.Find(".url") != -1) {
			data.flag = 0x05;
		} else {
			data.flag = 0x0d;
		}
		*/

		*(DWORD*)lpData = data.size;
		lpData += 4;
		*(DWORD*)lpData = data.priority;
		lpData += 4;
		int 	 size	= GetItemIdListSize(data.spidl.get());

		::memcpy(lpData, data.spidl.get(), size);
		lpData += size;

		if(data.padding) {
			*(BYTE*)lpData	= 0;
			lpData += 1;
		}
		*(DWORD*)lpData 	= data.flag;
		lpData += 4;

		if(lpData - data.size != lpStart) {
			ASSERT(true);
			delete[] lpMem;
			return FALSE;
		}
	}

	//f[^
  #if 1
	CString strRoot    = g_Options.strFavorites;
	CString strKeyName = _T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\MenuOrder\\Favorites");
	if (m_strFolder.GetLength() > strRoot.GetLength()) {
		CString strRelative = m_strFolder.Mid( strRoot.GetLength() + 1 );
		strKeyName += _T('\\') + strRelative;
	}
  #else
   /*
	CStdioFile file();
	CStdioFile fin(_T("C:\\Documents and Settings\\youhei\\fXNgbv\\reg2.bin"), CFile::modeCreate | CFile::modeWrite | CFile::typeBinary);
	fin.Write(lpMem, dwFullSize);
	fin.Close();
   */
  #endif

	// WXgɏ
	DWORD dwType = REG_BINARY;
	LONG  lRet	 = 0;
	HKEY  rkOrder; // L[̃nh
	lRet = ::RegCreateKeyEx(HKEY_CURRENT_USER, strKeyName, 0, NULL, 0, KEY_WRITE, NULL, &rkOrder, NULL);
	if (lRet != ERROR_SUCCESS) {
		return FALSE;
	}
	lRet = ::RegSetValueEx(rkOrder, _T("Order"), NULL, dwType, lpMem, dwFullSize);
	if (lRet != ERROR_SUCCESS) {
		return FALSE;
	}
	::RegCloseKey(rkOrder);

	//J
	delete[] lpMem;
	return TRUE;
}

/// z̕яWXgǂݍ
BOOL CFavoritesOrder::LoadOrder(LPCTSTR lpszFolder)
{
	typedef struct _tagCOrderTemplateData
	{
		DWORD		size;
		DWORD		priority;
		ITEMIDLIST	idl; // relative idlist
	} _COrderTemplateData;


	// pXƃL[
	m_strFolder = lpszFolder;
	if (m_strFolder.IsEmpty()) {
		return TRUE;
	}

	if (m_strFolder.Right(1) == _T("\\") ) {
		m_strFolder = m_strFolder.Left( m_strFolder.GetLength() - 1 );
	}
	ASSERT(!m_strFolder.IsEmpty());

	CString strRoot    = g_Options.strFavorites;
	CString strKeyName = _T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\MenuOrder\\Favorites");
	if (m_strFolder.GetLength() > strRoot.GetLength()) {
		CString strRelative = m_strFolder.Mid( strRoot.GetLength() + 1 );
		strKeyName += _T('\\') + strRelative;
	}

	// WXgf[^擾
	BYTE* pByte  = NULL;
	DWORD dwSize = 0;
	DWORD dwType = REG_BINARY;
	LONG  lRet	 = 0;
	HKEY  rkOrder;// L[̃nh
	lRet = ::RegOpenKeyEx(HKEY_CURRENT_USER, strKeyName, 0, 1, &rkOrder);
	if (lRet == ERROR_SUCCESS) {
		lRet = ::RegQueryValueEx(rkOrder, _T("Order"), NULL, &dwType, NULL, &dwSize);
		if (lRet == ERROR_SUCCESS && dwSize >= 12){
			pByte = (BYTE*)_alloca((dwSize+10) * sizeof(BYTE));
			::memset(pByte, 0, dwSize+10);
			lRet = ::RegQueryValueEx(rkOrder, _T("Order"), NULL, &dwType, pByte, &dwSize);
			if (lRet == ERROR_SUCCESS){
				::RegCloseKey(rkOrder);
			}
		}
	}

	if (pByte) {
		// oCif[^
		m_datalist.clear();
		m_header	= *(OrderDataHeader*)pByte;
		pByte	   += sizeof(OrderDataHeader);
		LPBYTE pEnd = pByte + dwSize;

		int count = m_header.dwItemCount;
		for(int i = 0; i < count; i++){
			_COrderTemplateData* pItem = (_COrderTemplateData*)pByte;
			CFavoritesOrderData data;
			data.size	  = pItem->size;
			data.priority = pItem->priority;
			data.SetPidl(&pItem->idl);

			if (GetItemIdListSize(data.spidl.get()) & 1) {
				data.padding = TRUE;
			} else {
				data.padding = FALSE;
			}
			data.flag = *(DWORD*)(pByte + pItem->size - sizeof(DWORD));

			// t@C
			TCHAR szFileName[MAX_PATH];
			BOOL bResult = ::SHGetPathFromIDList(data.spidl.get(), szFileName);
			if (bResult) {
				data.name = m_strFolder + _T("\\") + ::PathFindFileName(szFileName);
			}

			// D揇ʂɊÂđ}
			//+++ for (CFavoritesOrderDataVector::iterator pos = m_datalist.begin(); pos != m_datalist.end(); pos++) {
			CFavoritesOrderDataVector::iterator 	pos;
			for (pos = m_datalist.begin(); pos != m_datalist.end(); pos++) {
				CFavoritesOrderData& data2 = *pos;
				if (data.priority < data2.priority) {
					pos = m_datalist.insert(pos, data);
					break;
				}
			}
			if (pos == m_datalist.end()) {
				m_datalist.push_back(data);
			}

			// [vJE^XV
			pByte += pItem->size;
			if(pByte > pEnd) {
				break;
			}
		}
	}
	// ݃`FbN
	// WXgɓĂ邯Ǒ݂ȂtH_t@C
	CFavoritesOrderDataVector::iterator pos = m_datalist.begin();
	while (pos != m_datalist.end()) {
		CFavoritesOrderData& data = *pos;

		if (::PathFileExists(data.name)) {
			pos++;
		} else {
			pos = m_datalist.erase(pos);
		}
	}

	// WXgɓĂȂtH_t@C
	CStringArray arrBuf;
	LoadArrFolder( arrBuf, m_strFolder, _T(".url") );
	for (int i = 0; i < arrBuf.GetSize(); i++) {
		BOOL 	bExistInList = FALSE;
		CString strFileName  = m_strFolder + _T("\\") + arrBuf.GetAt(i);

		for (CFavoritesOrderDataVector::iterator pos = m_datalist.begin(); pos != m_datalist.end(); pos++) {
			CFavoritesOrderData& data = *pos;

			if (lstrcmp(strFileName, data.name) == 0) {
				bExistInList = TRUE;
				break;
			}
		}

		if (!bExistInList) {
			CFavoritesOrderData dataAdd;
			dataAdd.priority = -1;
			dataAdd.name	 = strFileName;

			m_datalist.push_back(dataAdd);
		}
	}
	return TRUE;
}

/// pXITEMIDLIST擾
ITEMIDLIST* CFavoritesOrder::GetItemIdList(LPCTSTR lpszPath)
{
	CComPtr<IShellFolder> spDesktopFolder;
	HRESULT hr = ::SHGetDesktopFolder(&spDesktopFolder);
	if (FAILED(hr)) {
		return NULL;
	}
	USES_CONVERSION;
	ITEMIDLIST* pidl	= NULL;
	ULONG 		chEaten;
	ULONG 		dwAttributes;
	hr 	= spDesktopFolder->ParseDisplayName(NULL, NULL, T2OLE((LPTSTR)lpszPath), &chEaten, &pidl, &dwAttributes);
	if (FAILED(hr)) {
		return NULL;
	}
	return pidl;
}

/// ITEMIDLIST̃TCY擾
int CFavoritesOrder::GetItemIdListSize(LPCITEMIDLIST pidl)
{
	UINT cbTotal = 0;
	if (pidl) {
		cbTotal += sizeof(pidl->mkid.cb);// Null terminator
		while (pidl->mkid.cb) {
			cbTotal += pidl->mkid.cb;
			// Next ITEMID
			LPBYTE lpMem = (LPBYTE)pidl;
			lpMem  += pidl->mkid.cb;
			pidl	= (LPITEMIDLIST)lpMem;
		}
	}
	return cbTotal;
}

/// ITEMIDLISTJ
BOOL CFavoritesOrder::ReleaseItemIdList(ITEMIDLIST* pidl)
{
	if (pidl) {
		::CoTaskMemFree(pidl);
	}
	TRACE("CFavoritesOrder::ReleaseItemIdList");
	return TRUE;
}

/// ITEMIDLIST쐬
LPITEMIDLIST CFavoritesOrder::CreateItemIdList(UINT cbSize)
{
	LPITEMIDLIST pidl = reinterpret_cast<LPITEMIDLIST>(CoTaskMemAlloc(cbSize));
	return pidl;
}

/// ITEMIDLIST擾
LPITEMIDLIST CFavoritesOrder::ConvertItemIDListRelative(LPCITEMIDLIST pidl1, LPCITEMIDLIST pidl2)
{
	if (pidl1==NULL) {
		return NULL;
	}

	UINT cb1 = GetItemIdListSize(pidl1);
	UINT cb2 = 0;
	if (pidl2) {
		cb2 = GetItemIdListSize(pidl2) - sizeof(pidl2->mkid.cb);
	}
	if (cb1 <= cb2) {
		return NULL;
	}

	LPITEMIDLIST pidlNew = CreateItemIdList(cb1 - cb2);
	if (pidlNew) {
		if (pidl1) {
			::memcpy(pidlNew, ((LPSTR)pidl1) + cb2, cb1 - cb2);
		}
		ASSERT((UINT)GetItemIdListSize(pidlNew) == cb1 - cb2);
	}
	return pidlNew;
}

/// ACëʒuύX
BOOL CFavoritesOrder::Move(int nOldIndex, int nNewIndex)
{
	if (nOldIndex == nNewIndex) {
		return TRUE;
	}

	int index = 0;

	// ړΏۃACe擾
	CFavoritesOrderDataVector::iterator pos = m_datalist.begin() + nOldIndex;

	// D揇ʂXV
	CFavoritesOrderData dataTarget = *pos; // Rs[
	dataTarget.SetPriority(nNewIndex);
	m_datalist.erase(pos);

	if (nOldIndex < nNewIndex) {
		nNewIndex--;
	}

	// Vʒuɑ}
	pos = m_datalist.begin() + nNewIndex;
	if (pos == m_datalist.end()) {
		pos--;
	}
	m_datalist.insert(pos, dataTarget);

	// Ŝ̗D揇ʂXV
	pos = m_datalist.begin();
	index = 0;
	while (index <= nOldIndex || index <= nNewIndex + 1) {
		CFavoritesOrderData& data = *pos;
		data.SetPriority(index);

		pos++;
		index++;
	}
	return TRUE;
}

/// ACeύX
BOOL CFavoritesOrder::Rename(int Index, LPCTSTR lpszFileName)
{
	// ړΏۃACe擾
	CFavoritesOrderDataVector::iterator pos = m_datalist.begin() + Index;
	CFavoritesOrderData& dataTarget = *pos;
	dataTarget.name = lpszFileName;
	if (dataTarget.name.Find(_T("\\")) == -1) {
		dataTarget.name = m_strFolder + _T("\\") + dataTarget.name;
	}
	dataTarget.RefreshIdl();
	return TRUE;
}

/// ACetH_ɒǉ
BOOL CFavoritesOrder::Insert(int InsertIndex, LPCTSTR lpszFileName)
{
	// d폜
	CFavoritesOrderDataVector::iterator pos = m_datalist.begin();
	while (pos != m_datalist.end()) {
		CFavoritesOrderData& data = *pos;
		if (data.name == lpszFileName) {
			if (data.priority < InsertIndex) {
				InsertIndex--;
			}
			pos = m_datalist.erase(pos);
			break;
		} else {
			pos++;
		}
	}

	int 	index = 0;

	// }ACe쐬
	CFavoritesOrderData dataTarget;
	dataTarget.name 	= lpszFileName;
	if (dataTarget.name.Find(_T("\\")) == -1) {
		dataTarget.name = m_strFolder + _T("\\") + dataTarget.name;
	}
	dataTarget.SetPriority(InsertIndex);
	// w肵ʒuɑ}
	pos = m_datalist.begin();
	for (index = 0; index < InsertIndex && pos != m_datalist.end(); index++) {
		CFavoritesOrderData&	data = *pos;
		data.SetPriority(index);
		pos++;
	}
	if (pos != m_datalist.end()) {
		m_datalist.insert(pos, dataTarget);
		// Ŝ̗D揇ʂXV
		index++;
		int 	count = int( m_datalist.size() );
		ASSERT(m_datalist.size() < 0x7fffffff);
		while (pos != m_datalist.end() && index < count) {
			CFavoritesOrderData& data = *pos;
			if (data.priority == -1) {
				break;
			}
			data.SetPriority(index);
			pos++;
			index++;
		}
	} else {
		m_datalist.push_back(dataTarget);
	}
	return TRUE;
}

/// ACe폜
BOOL CFavoritesOrder::Delete(int TargetIndex)
{
	ASSERT( size_t(TargetIndex) < m_datalist.size() );

	// w肵ʒu폜
	CFavoritesOrderDataVector::iterator pos = m_datalist.begin() + TargetIndex;
	if (pos != m_datalist.end()) {
		pos  = m_datalist.erase(pos);
	} else {
		return FALSE;
	}

	// Ŝ̗D揇ʂXV
	int 	index = TargetIndex;
	int 	count = int( m_datalist.size() );
	ASSERT( m_datalist.size() < 0x7fffffff );
	while (pos != m_datalist.end() && index < count) {
		CFavoritesOrderData& data = *pos;
		if (data.priority == -1) {
			break;
		}

		data.SetPriority(-1);
		data.SetPriority(index);
		pos++;
		index++;
	}
	return TRUE;
}

/// z̃TCY擾
int CFavoritesOrder::GetCount()
{
	return int( m_datalist.size() );
}

///////////////////////////////////////////////////////////////////
// CFavoritesOrderData
///////////////////////////////////////////////////////////////////

/// RXgN^
CFavoritesOrder::CFavoritesOrderData::CFavoritesOrderData()
	: padding(FALSE)
	, size(0)
	, priority(-1)
	, flag(0)
	, spidl()
	, name()
{
}

/// Rs[RXgN^
CFavoritesOrder::CFavoritesOrderData::CFavoritesOrderData(const CFavoritesOrderData& data)
{
	*this = data;
}

/// fXgN^
CFavoritesOrder::CFavoritesOrderData::~CFavoritesOrderData()
{
	// ITEMIDLIST J
	//CFavoritesOrder::ReleaseItemIdList(spidl);
}

/// D揇ʂݒ
void CFavoritesOrder::CFavoritesOrderData::SetPriority(int _priority)
{
	if (priority == -1 && _priority != -1) {
		RefreshIdl();
	}
	priority = _priority;
}

/// IDLIST ݒ
void CFavoritesOrder::CFavoritesOrderData::SetPidl(ITEMIDLIST* _pidl)
{
	if (_pidl == NULL) {
		return;
	}
	UINT		cbSize	= CFavoritesOrder::GetItemIdListSize(_pidl);

	ITEMIDLIST* pNewIdl = CreateItemIdList(cbSize);
	spidl.reset(pNewIdl, ReleaseItemIdList);

	::memcpy(spidl.get(), _pidl, cbSize);
	/*
	ReleaseItemIdList(pidl);

	if (_pidl == NULL) {
		return;
	}
	UINT cbSize = CFavoritesOrder::GetItemIdListSize(_pidl);
	pidl = CreateItemIdList(cbSize);
	::memcpy(pidl, _pidl, cbSize);
	*/
}

/// oCg擾
int CFavoritesOrder::CFavoritesOrderData::GetSize()
{
	int nSize = CFavoritesOrder::GetItemIdListSize(spidl.get());
	padding   = (nSize & 1) ? TRUE : FALSE;
	size	  = nSize + s_itemsize_without_idl + (padding ? 1 : 0);
	return size;
}

/// ITEMIDLIST XV
void CFavoritesOrder::CFavoritesOrderData::RefreshIdl()
{
	// ΃pXITEMIDLIST擾
	LPITEMIDLIST		pAbsIdl = CFavoritesOrder::GetItemIdList(name);
	ItemIdListSharedPtr spAbsIdl(pAbsIdl, ReleaseItemIdList);

	CString 			dirname = ::PathGetParentDirectory(name);
	LPITEMIDLIST		pDirIdl = CFavoritesOrder::GetItemIdList(dirname);
	ItemIdListSharedPtr spDirIdl(pDirIdl, ReleaseItemIdList);

	LPITEMIDLIST		pRelativeIdl = CFavoritesOrder::ConvertItemIDListRelative(pAbsIdl, pDirIdl);
	spidl.reset(pRelativeIdl, ReleaseItemIdList);

	// TCY擾
	GetSize();
}

/// Zq
CFavoritesOrder::CFavoritesOrderData& CFavoritesOrder::CFavoritesOrderData::operator=(const CFavoritesOrderData& data)
{
	flag		= data.flag;
	name		= data.name;
	padding 	= data.padding;
	priority	= data.priority;
	size		= data.size;
	spidl		= data.spidl;
	return *this;
}
