// MainFrm.h : CMainFrame NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__2678F548_D704_11D5_8799_E58356340A34__INCLUDED_)
#define AFX_MAINFRM_H__2678F548_D704_11D5_8799_E58356340A34__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "TabsCollection.h"
#include "FiltersCollection.h"
#include "PatriotGestureManager.h"

#include "PatriotSidebar.h"
#include "PatriotAddress.h"
#include "PatriotTabbar.h"
#include "PatriotSearchbar.h"
#include "PatriotToolbar.h"
#include "PatriotLinkbar.h"
#include "PatriotStatusbar.h"
#include "menubar.h"
#include "UrllistFile.h"

class CFolderMenuManager;
class CFavoritesMenuManager;
class CSendMenuManager;
class CProxyMenuManager;
class CExtensionMenuManager;

enum { SPMENU_CLOSED, SPMENU_FONT, SPMENU_SENDURL, SPMENU_SENDSTR, SPMENU_PROXY, SPMENU_MEDIA, SPMENU_SECURE, SPMENU_COOKIE, SPMENU_FAV, SPMENU_NEW, SPMENU_OPTION, SPMENU_EXTENSION };
enum { REBAR_MENUBAR, REBAR_TOOLBAR, REBAR_SEARCHBAR, REBAR_ADDRESSBAR, REBAR_LINKBAR, REBAR_TABBAR };
enum { RELOAD_GLOBAL_SETTING, RELOAD_SETTING_CACHE, RELOAD_SETTING_EXTENTION };

UINT ExecPluginThread(LPVOID lpArg);

#define ID_SC_SHOWREBAR  0x0010

class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

// Agr[g
public:
	BOOL			bGestured;				//+++ : A@\jŖgp(e)ȕϐ.
	CMenu			menuCustom;
	NOTIFYICONDATA	m_stNotifyIcon;

protected:
	void	SetChevronSize();

	void	ReloadGlobalSetting();
// Iy[V
public:
	void	PopupToolbar(UINT nID, CMenu* pMenu);

	void	SetTab(int index);
	void	RefreshTab(int index);

	void	CreateClosedMenu( CMenu* pMenu = NULL );
	void	CreateEncodeMenu( CMenu* pMenu = NULL );
	void	CreateCustomMenu( CMenu* pMenu, CString strSession );

	int 	GetBandIndex( CWnd* wnd );
	CMenu*	GetSpecialMenu( int Id );

	void	TabmodeResize();
	CRect	CalcTabmodeSize();

	void	SaveBackup();
	static BOOL ExecPlugin(const CString& strDll, const CString& strFunc, const CString& strParam);
	static UINT ExecPluginThread(LPVOID lpArg);
	BOOL	ExecExtension(CString strExtensionName);

	LRESULT OnActiveView(WPARAM index);
	LRESULT OnDocumentComplate(WPARAM index);
	LRESULT OnSizeTabbar();

	/// ^u`ʍXṼbN
	BOOL	LockTabUpdate();
	///^u`ʍXṼbN
	BOOL	UnlockTabUpdate();

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL LoadFrame(UINT nIDResource, DWORD dwDefaultStyle = WS_OVERLAPPEDWINDOW  | FWS_ADDTOTITLE , CWnd* pParentWnd = NULL, CCreateContext* pContext = NULL);
	protected:
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL
	virtual void GetMessageString( UINT nID, CString& rMessage ) const;

// Cve[V
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:
	// Rg[ o[po
	CReBar					m_wndReBar;
	CReBar					m_wndReBar2;
	CPatriotAddress 		m_wndAddressBar;
	CPatriotToolbar 		m_wndToolBar;
	CPatriotSidebar 		m_wndSideBar;
	CPatriotTabbar			m_wndTabBar;
	CPatriotSearchbar		m_wndSearchBar;
	CPatriotLinkbar 		m_wndLinkBar;
	CMenuBar				m_wndMenuBar;
	PatriotStatusbar		m_wndStatusBar;

	// }EXWFX`
	CPatriotGestureManager	m_Gesture;

	// ^uȂ
	CTabsCollection 		m_Tabs;
	CFiltersCollection		m_Filters;
	CFiltersCollection		m_FavFilters;

	/// ^u`ʂ̃bN
	BOOL					m_bLockTabUpdate;

	/// URLXgj[
	CFolderMenuManager* 	m_pUrllistMenu;
	/// Cɓ胁j[
	CFavoritesMenuManager*	m_pFavoritesMenu;
	/// uI𕶎𑗂vj[
	CSendMenuManager*		m_pSendStrMenu;
	/// uURL𑗂vj[
	CSendMenuManager*		m_pSendUrlMenu;
	/// vNVj[
	CProxyMenuManager*		m_pProxyMenu;
	/// g@\j[
	CExtensionMenuManager*	m_pExtensionMenu;

	// ŋߕy[W
	CUrllistFile			fileClosedUrl;

// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnFavoritesEditurllist();
	afx_msg void OnFavoritesSaveurllist();
	afx_msg void OnFavoritesEdit();
	afx_msg void OnToolShowstatus();
	afx_msg void OnUpdateToolShowstatus(CCmdUI* pCmdUI);
	afx_msg void OnWindowBacktab();
	afx_msg void OnWindowNexttab();
	afx_msg void OnWindowMoveright();
	afx_msg void OnWindowMoveleft();
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnViewAddressbar();
	afx_msg void OnUpdateViewAddressbar(CCmdUI* pCmdUI);
	afx_msg void OnViewTabbar();
	afx_msg void OnUpdateViewTabbar(CCmdUI* pCmdUI);
	afx_msg void OnViewSidebar();
	afx_msg void OnUpdateViewSidebar(CCmdUI* pCmdUI);
	afx_msg void OnViewSearchbar();
	afx_msg void OnUpdateViewSearchbar(CCmdUI* pCmdUI);
	afx_msg void OnClose();
	afx_msg void OnViewToolbar();
	afx_msg void OnUpdateViewToolbar(CCmdUI* pCmdUI);
	afx_msg void OnFileOpenclip();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnToolOption();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnFileBackup();
	afx_msg void OnViewFocusAddress();
	afx_msg void OnViewFocusSearch();
	afx_msg void OnViewFocusView();
	afx_msg void OnViewFocusSidebar();
	afx_msg void OnToolUsecookie();
	afx_msg void OnUpdateToolUsecookie(CCmdUI* pCmdUI);
	afx_msg void OnToolUsecookiesession();
	afx_msg void OnUpdateToolUsecookiesession(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOffline(CCmdUI* pCmdUI);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnViewRebar2();
	afx_msg void OnUpdateViewRebar2(CCmdUI* pCmdUI);
	afx_msg BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);
	afx_msg void OnViewLinkbar();
	afx_msg void OnUpdateViewLinkbar(CCmdUI* pCmdUI);
	afx_msg void OnFileCloseexcept();
	afx_msg void OnFileCloseleft();
	afx_msg void OnFileCloseright();
	afx_msg void OnHelpGoofficial();
	afx_msg void OnViewKeyboard();
	afx_msg void OnUpdateViewKeyboard(CCmdUI* pCmdUI);
	afx_msg void OnWindowMovefirst();
	afx_msg void OnWindowMovelast();
	afx_msg void OnWindowFirsttab();
	afx_msg void OnWindowLasttab();
	afx_msg void OnWindowSorturl();
	afx_msg void OnPopupAddress();
	afx_msg void OnViewFixedbar();
	afx_msg void OnUpdateViewFixedbar(CCmdUI* pCmdUI);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnViewStatusBar();
	afx_msg void OnToolOptiontoolbar();
	afx_msg void OnToolOptionextension();
	afx_msg void OnFileCloseall();
	afx_msg void OnViewRefreshall();
	afx_msg void OnViewStopall();
	afx_msg void OnPopupProxy();
	afx_msg void OnToolCloseerrordlg();
	afx_msg void OnUpdateToolCloseerrordlg(CCmdUI* pCmdUI);
	afx_msg void OnToolOptionsendstr();
	afx_msg void OnFileOffline();
	afx_msg void OnViewFontsize();
	afx_msg void OnViewSideAutohide();
	afx_msg void OnUpdateViewSideAutohide(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnWindowTileVert();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnWindowTileHorz();
	afx_msg void OnUpdateToolFilteruse(CCmdUI* pCmdUI);
	afx_msg void OnToolFilteruse();
	afx_msg void OnToolInternetoption();
	afx_msg void OnViewHome();
	afx_msg void OnPopupClosedUrl();
	afx_msg void OnPopupFindpage();
	//}}AFX_MSG
	afx_msg void OnDropDown(NMHDR* pNotifyStruct, LRESULT* pResult);
	afx_msg void OnFileUsedurlUpdate(CCmdUI* pCmdUI);
	afx_msg void OnFavoritesFavorites(UINT nID);
	afx_msg void OnFavoritesOpenAll(UINT nID);
	afx_msg void OnFavoritesAddHere(UINT nID);
	afx_msg void OnFavoritesUrllist(UINT nID);
	afx_msg void OnFileUsedurl(UINT nID);
	afx_msg void OnToolProxy(UINT nID);
	afx_msg void OnToolProxyUpdate(CCmdUI* pCmdUI);
	afx_msg void OnExtensionExtension(UINT nID);
	afx_msg void OnUpdateExtensionExtension(CCmdUI* pCmdUI);
	afx_msg void OnViewSidebarIndex(UINT nID);
	afx_msg void OnViewSidebarIndexUpdate(CCmdUI* pCmdUI);
	afx_msg void OnLinkbarLink(UINT nID);
	afx_msg void OnSpecialKeyemu(UINT nID);
  #if _MSC_VER >= 1300	//+++ vc7MFC̃T|[g...
	afx_msg BOOL OnChevronPushed(UINT id, NMHDR *pnm, LRESULT *result);
  #else 				//+++ vc6 ɂ͂Ȃ̂ buraƎ(Ԃ)
	afx_msg void OnChevronPushed( NMHDR * pNotifyStruct, LRESULT* result );
  #endif
	afx_msg LRESULT OnReplaceTab(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg LRESULT OnInsertTab(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg LRESULT OnTrackPopupMenu(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg LRESULT OnReloadSetting(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg LRESULT OnGetMainMenu(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg void 	OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void 	OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	afx_msg void 	OnSettingChange(UINT uFlags, LPCTSTR lpszSection);
	afx_msg LRESULT OnMenuChar(UINT nChar, UINT nFlags, CMenu* pMenu);
	afx_msg LRESULT OnSetMessageString(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_MAINFRM_H__2678F548_D704_11D5_8799_E58356340A34__INCLUDED_)
