/////////////////////////////////////////////////////////////////////////////
// SidebarUrllist.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "SidebarUrllist.h"
#include "patriotGlobal.h"
#include "EditUrlListDlg.h"
#include "UrllistFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSidebarUrllist

CSidebarUrllist::CSidebarUrllist()
{
}

CSidebarUrllist::~CSidebarUrllist()
{
}

BEGIN_MESSAGE_MAP(CSidebarUrllist, CFileTreeCtrl)
	//{{AFX_MSG_MAP(CSidebarUrllist)
	ON_WM_CREATE()
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDING, OnItemexpanding)
	ON_COMMAND(ID_SIDEBAR_OPEN, OnSidebarOpen)
	ON_COMMAND(ID_SIDEBAR_OPENNEW, OnSidebarOpennew)
	ON_COMMAND(ID_SIDEBAR_REFRESHALL, OnSidebarRefreshall)
	ON_COMMAND(ID_SIDEBAR_PROPERTY, OnSidebarProperty)
	ON_COMMAND(ID_SIDEBAR_DELETE, OnSidebarDelete)
	ON_COMMAND(ID_SIDEBAR_RENAME, OnSidebarRename)
	ON_COMMAND(ID_SIDEBAR_NEWFOLDER, OnSidebarNewfolder)
	ON_COMMAND(ID_SIDEBAR_NEW, OnSidebarNew)
	ON_COMMAND(ID_SIDEBAR_ADD, OnSidebarAdd)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	ON_WM_TIMER()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_NOTIFY_REFLECT(NM_CLICK, OnClick)
	ON_NOTIFY_REFLECT(TVN_ENDLABELEDIT, OnEndlabeledit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSidebarUrllist o֐

/// J
BOOL CSidebarUrllist::OpenFile(BOOL bNewWindow)
{
	if (ItemIsFolder(GetSelectedItem())) {
		return FALSE;
	}
	CString 	strFileName = GetSelectedFileName();
	OpenFileUrllist(strFileName);
	return TRUE;
}

/// j[擾
CMenu* CSidebarUrllist::GetContextMenu()
{
	CMenu* pMenu = new CMenu;
	pMenu->LoadMenu(IDR_SIDEBARURLLIST);

	if (ItemIsFolder(GetSelectedItem())) {
		pMenu->GetSubMenu(0)->DeleteMenu(ID_SIDEBAR_ADD 	 , MF_BYCOMMAND);
		pMenu->GetSubMenu(0)->DeleteMenu(ID_SIDEBAR_PROPERTY , MF_BYCOMMAND);
		pMenu->GetSubMenu(0)->DeleteMenu(0 , MF_BYPOSITION);
	}
	return pMenu;
}

/////////////////////////////////////////////////////////////////////////////
// CSidebarUrllist bZ[W nh

int CSidebarUrllist::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFileTreeCtrl::OnCreate(lpCreateStruct) == -1) {
		return -1;
	}

	CString strPath = g_Options.strUrllistPath;
	SetOption( strPath, _T(".bul"), 4, 5 );
	return 0;
}

/// vpeB
void CSidebarUrllist::OnSidebarProperty()
{
	if (ItemIsFolder(GetSelectedItem())) {
		return;
	}
	CEditUrlListDlg dlg( GetSelectedFileName() );
	if (dlg.DoModal() == IDOK) {
		OnSidebarRefreshall();
	}
}

/// ANeBuǉ
void CSidebarUrllist::OnSidebarAdd()
{
	CMDIFrameWnd* pFrame = (CMDIFrameWnd*)AfxGetMainWnd();
	if (!pFrame->MDIGetActive())
		return;

	CString 	strPath = GetSelectedFileName();
	CHtmlView2* pView 	= (CHtmlView2*)pFrame->MDIGetActive()->GetActiveView();

	CUrllistFile file;
	file.Load( strPath );
	file.AddView( pView );
	file.Save( strPath );

	/*
	TCHAR chrSetting[12];
	pView->SendMessage(WM_SAVESTRSETTING , (int)&chrSetting[0]);

	CString str , str2;
	CStdioFile fin(strPath , CFile::modeRead);
	while(fin.ReadString(str2))
		str += str2 +  _T("\n");
	fin.Close();

	CStdioFile fin2(strPath , CFile::modeCreate | CFile::modeWrite | CFile::typeText );
	fin2.WriteString(str);
	fin2.WriteString(pView->GetLocationURL()+ _T("\n") );
	fin2.WriteString(chrSetting);
	fin2.WriteString( _T("\n\n") );
	fin2.Close();
	*/
}

/// VURLXg
void CSidebarUrllist::OnSidebarNew()
{
	CString strPath = GetSelectedFileName();
	if (strPath.GetAt(strPath.GetLength()-m_strSuffix.GetLength()) == '.') {
		strPath = strPath.Left(strPath.ReverseFind('\\'));
	}

	// c[ɃACeǉ
	HTREEITEM	item = GetSelectedItem();
	if (!ItemIsFolder(item)) {
		item = GetParentItem(item);
	}

	HTREEITEM	itemNew;
	if (!(GetItemState(item , TVIS_EXPANDED) & TVIS_EXPANDED)) {
		Expand(item , TVE_EXPAND);
	}
	DoEvents();//Cxg
	CTime 	time 		= CTime::GetCurrentTime();
	CString strFileName = time.Format( _T("%y-%m-%d_%H-%M") );
	itemNew 			= InsertItem( strFileName, m_iIconN, m_iIconS, item, TVI_LAST );

	//+++ CStdioFile fs( strPath + _T("\\") + strFileName + m_strSuffix, CFile::modeCreate | CFile::modeWrite );
	CWriteTextFile fs( strPath + _T("\\") + strFileName + m_strSuffix, CFile::modeCreate | CFile::modeWrite );
	fs.Close();

	// O̕ύX
	SelectItem(itemNew);
	m_ClickedItem = item;
	OnSidebarRename();
}

/// Nhbvꂽ
BOOL CSidebarUrllist::OnDropLink( HTREEITEM ItemDrop, CString strTitle, CString strURL )
{
	// hbṽtH_
	CPoint point;
	GetCursorPos(&point);
	ScreenToClient(&point);
	HTREEITEM item = HitTest(point);
	if (item == NULL) {
		return TRUE;
	}
	CString strPath = GetItemFileName(item);
	if (ItemIsFolder(item)) {
		strPath += _T("\\") + PathGetTitle(strTitle) + _T(".bul");
	}

	CUrllistItem* pItem = new CUrllistItem;
	pItem->strURL 		= strURL;
	pItem->strTitle 	= strTitle;
	pItem->strSetting 	= _T("22222222222");

	CUrllistFile file;
	file.Load(strPath);
	file.Add(pItem);
	file.Save(strPath);
	return TRUE;
}
