// PageMouse2.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageMouse2.h"
#include "GestureDlg.h"
#include "../GestureManager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageMouse2 vpeB y[W

IMPLEMENT_DYNCREATE(CPageMouse2, CPropertyPage)

CPageMouse2::CPageMouse2()
	: CPropertyPage(CPageMouse2::IDD)
	, m_IDMap()
	, arrMouseAction()
	, arrMouseCommand()
	, m_LineColor()
	, m_TextColor()
	, m_List1()
{
	//{{AFX_DATA_INIT(CPageMouse2)
	m_UseGesture = FALSE;
	m_DrawLine	 = FALSE;
	m_MinPix	 = 0;
	//}}AFX_DATA_INIT
}

CPageMouse2::~CPageMouse2()
{
}

void CPageMouse2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageMouse2)
	DDX_Control(pDX, IDC_LIST1, m_List1);
	DDX_Check(pDX, IDC_CHECK1, m_UseGesture);
	DDX_Check(pDX, IDC_CHECK2, m_DrawLine);
	DDX_Text(pDX, IDC_EDIT1, m_MinPix);
	DDV_MinMaxUInt(pDX, m_MinPix, 5, 100);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageMouse2, CPropertyPage)
	//{{AFX_MSG_MAP(CPageMouse2)
	ON_BN_CLICKED(IDC_BUTTON11, OnButton11)
	ON_BN_CLICKED(IDC_BUTTON13, OnButton13)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST1, OnDblclkList1)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageMouse2 bZ[W nh

BOOL CPageMouse2::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// WFX`[
	m_MinPix		= g_Options.MouseMinPixel;
	m_DrawLine		= g_Options.MouseDrawLine;
	m_UseGesture	= g_Options.MouseUseGesture;
	m_LineColor 	= g_Options.MouseLineColor;
	m_TextColor 	= g_Options.MouseTextColor;
	UpdateData(FALSE);

	// XgRg[쐬
	m_List1.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_List1.InsertColumn( 0, _T("ANV"), NULL, 200 );
	m_List1.InsertColumn( 1, _T("R}h"),   NULL, 200 );

	// Xgɒǉ
	CGestureManager manager( g_Options.strOptionPath + _T("\\gesture.dat") );

	// ǂݍ
	manager.LoadSetting();

	// zɃRs[
	CString str;
	for (int i = 0; i < manager.arrMouseAction.GetSize(); i++) { // [h
		arrMouseAction.Add(manager.arrMouseAction.GetAt(i));
		arrMouseCommand.Add(manager.arrMouseCommand.GetAt(i));

		m_List1.InsertItem( i, arrMouseAction.GetAt(i), 0);
		m_List1.SetItemText( i, 1, m_IDMap.Lookup(arrMouseCommand.GetAt(i)) );
	}
	if ( m_List1.GetItemCount() > 0 ) {
		m_List1.SetItemState( 0, 2, LVIS_SELECTED );
	}
	// WFX`[̗LE
	OnCheck1();
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CPageMouse2::OnOK()
{ // ݒۑ
	// }EX2
	g_Options.MouseMinPixel 	= m_MinPix;
	g_Options.MouseDrawLine 	= m_DrawLine;
	g_Options.MouseUseGesture	= m_UseGesture;
	g_Options.MouseLineColor	= m_LineColor;
	g_Options.MouseTextColor	= m_TextColor;

	SaveGesture();
	CPropertyPage::OnOK();
}

void CPageMouse2::OnDblclkList1(NMHDR* pNMHDR, LRESULT* pResult)
{
	int index = m_List1.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );
	if (index > -1) {
		// _CAO\
		CGestureDlg dlg;
		dlg.m_MinPixel		  = m_MinPix;
		dlg.m_strMouseCommand = arrMouseAction.GetAt(index);
		dlg.m_nCommand		  = arrMouseCommand.GetAt(index);
		if ( dlg.DoModal()==IDOK ) {
			ReplaceItem( index, dlg.m_strMouseCommand, UINT( dlg.m_nCommand ) );
			return;
		}
	}
	*pResult = 0;
}

void CPageMouse2::OnButton11()
{// ǉ
	CGestureDlg dlg;
	dlg.m_MinPixel = m_MinPix;
	if (dlg.DoModal()==IDCANCEL) {
		return;
	}

	int 	index = m_List1.GetItemCount();
	CString str   = dlg.m_strMouseCommand;
	UINT	nCmd  = UINT( dlg.m_nCommand );

	// d`FbN
	if (arrMouseAction.GetSize()>0) {
		for (int i = 0;i<arrMouseAction.GetSize();i++) {
			if (arrMouseAction.GetAt(i) == str) { // dĂ
				m_List1.SetItemState(i, 2, LVIS_SELECTED);

				if (AfxMessageBox( _T("̃WFX`[͂ł \"") + m_IDMap.Lookup(arrMouseCommand.GetAt(i)) + _T("\" Ɋ蓖ĂĂ܂B\nu܂H")  , MB_OKCANCEL | MB_ICONQUESTION) == IDOK) {
					ReplaceItem( i, str, nCmd );
				}
				return;
			}
		}
	}

	arrMouseAction.Add(str);
	arrMouseCommand.Add(nCmd);

	m_List1.InsertItem( index, str );
	m_List1.SetItemText( index, 1, m_IDMap.Lookup(nCmd) );
	m_List1.SetItemState( index, 2, LVIS_SELECTED );
	m_List1.EnsureVisible( index, TRUE );
}

void CPageMouse2::OnButton13()
{ // 폜
	POSITION pos   = m_List1.GetFirstSelectedItemPosition();
	int 	 index = m_List1.GetNextSelectedItem(pos);
	if (index == -1) {
		return;
	}

	m_List1.DeleteItem(index);
	arrMouseAction.RemoveAt(index);
	arrMouseCommand.RemoveAt(index);

	if (m_List1.GetItemCount()>0) {
		if (m_List1.GetItemCount() <= index) // CfbNX蓖
			m_List1.SetItemState(m_List1.GetItemCount()-1 , 2 , LVIS_SELECTED);
		else
			m_List1.SetItemState(index , 2 , LVIS_SELECTED);
	}
//	OnSelchangeCombo1();
}

void CPageMouse2::OnButton1()
{ // ړ̐F
	CColorDialog dlg;
	dlg.SetCurrentColor(m_LineColor);
	dlg.DoModal();
	m_LineColor = dlg.GetColor();
}

void CPageMouse2::OnButton2()
{ // ̐F
	CColorDialog dlg;
	dlg.SetCurrentColor(m_TextColor);
	dlg.DoModal();
	m_TextColor = dlg.GetColor();
}


void CPageMouse2::SaveGesture()
{
	if (arrMouseAction.GetSize() == 0) {
		return;
	}

	// pXݒ
	CGestureManager manager( g_Options.strOptionPath + _T("\\gesture.dat") );

	// z񂩂Rs[
	manager.arrMouseAction.RemoveAll();
	manager.arrMouseCommand.RemoveAll();
	for (int i = 0; i < arrMouseAction.GetSize(); i++) {
		manager.arrMouseAction.Add( arrMouseAction.GetAt(i) );
		manager.arrMouseCommand.Add( arrMouseCommand.GetAt(i) );
	}
	// ۑ
	manager.SaveSetting();
}

void CPageMouse2::ReplaceItem( int nIndex, CString strAction, UINT nCommand )
{
	if (nIndex == -1) {
		return;
	}

	arrMouseAction.SetAt (nIndex, strAction);
	arrMouseCommand.SetAt(nIndex, nCommand);
	m_List1.SetItemText(nIndex, 0, strAction);
	m_List1.SetItemText(nIndex, 1, m_IDMap.Lookup(nCommand) );
}

void CPageMouse2::OnCheck1()
{
	CButton* pButton	= static_cast<CButton*>( GetDlgItem(IDC_CHECK1) );
	BOOL	 bChecked	= pButton->GetCheck();

	UINT	 nWndIDs[6] = { IDC_BUTTON11, IDC_BUTTON13,IDC_LIST1 };
	for (UINT* p = nWndIDs; *p != 0; p++) {
		GetDlgItem(*p)->EnableWindow(bChecked);
	}
}
